{% extends "customers/base.html" %}
{% load i18n %}
{% load widget_tweaks %}

{% block title %}Monitoreo exploratorio{% endblock %}

{% block page %}
<!-- begin breadcrumb -->
<ol class="breadcrumb float-xl-right">
  <li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
  <li class="breadcrumb-item"><a href="{% url 'qa-monitoring-list' %}">Listado monitoreo exploratorio</a></li>
  <li class="breadcrumb-item active">Crear monitoreo exploratorio</li>
</ol>
<!-- end breadcrumb -->
<!-- begin page-header -->
<h1 class="page-header">Monitoreo exploratorio <small>Crear</small></h1>
<!-- end page-header -->

<!-- begin row -->
<div class="row">
    {% if form %}
    <!-- begin col-12 -->
    <div class="col-xl-12">
      <!-- begin panel -->
      <div class="panel panel-inverse" data-sortable-id="table-basic-1">
        <!-- begin panel-heading -->
        <div class="panel-heading">
          <h4 class="panel-title">Monitoreo exploratorio</h4>
          <div class="panel-heading-btn">
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
          </div>
        </div>
        <!-- end panel-heading -->
        <div class="panel-body">

              <form id="call-qa-form" class="form-horizontal" method="post">
                {% csrf_token %}		

                <div class="row justify-content-center">
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.date.auto_id }}">{{ form.date.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.date class="form-control m-b-5" %}

                      {% for error in form.date.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.agent.auto_id }}">{{ form.agent.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.agent class="form-control m-b-5" %}

                      {% for error in form.agent.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.phone.auto_id }}">{{ form.phone.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.phone class="form-control m-b-5" %}

                      {% for error in form.phone.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                      <small id="phone-format-error" class="f-s-12 text-danger d-none"></small>
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.email.auto_id }}">{{ form.email.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.email class="form-control m-b-5" %}

                      {% for error in form.email.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                      <small id="email-format-error" class="f-s-12 text-danger d-none"></small>
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.rut.auto_id }}">{{ form.rut.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.rut class="form-control m-b-5" maxlength="12"%}

                      {% for error in form.rut.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                      <small id="rut-format-error" class="f-s-12 text-danger d-none"></small>
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.service.auto_id }}">{{ form.service.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      <select id="id_service" name="service" class="form-control m-b-5">
                        <option value="">-----</option>
                      </select>

                      {% for error in form.service.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.subcategory.auto_id }}">{{ form.subcategory.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.subcategory class="form-control m-b-5"%}

                      {% for error in form.subcategory.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}                      
                    </div>
                  </div>
                </div>
                <div class="row m-t-15 m-b-15">
                  <div class="col-sm-12">
                    <label for="{{ form.address.auto_id }}">{{ form.address.label }}</label>
                  </div>
                  <div class="col-sm-12">
                    {% render_field form.address class="form-control m-b-5" %}

                    {% for error in form.addres.errors %}
                    <small class="f-s-12 text-danger">{{ error }}</small>
                    {% endfor %}
                  </div>
                </div>
                <div class="row m-t-15 m-b-15">
                  <div class="col-sm-12">
                    <label for="{{ form.reason.auto_id }}">{{ form.reason.label }}</label>
                  </div>
                  <div class="col-sm-12">
                    {% render_field form.reason class="form-control m-b-5" %}

                    {% for error in form.reason.errors %}
                    <small class="f-s-12 text-danger">{{ error }}</small>
                    {% endfor %}
                  </div>
                </div>
                <div class="row m-t-15 m-b-15">
                  <div class="col-12">
                    <label for="{{ form.comment.auto_id }}">{{ form.comment.label }}</label>
                  </div>
                  <div class="col-12">
                    {% render_field form.comment class="form-control m-b-5" %}

                    {% for error in form.comment.errors %}
                    <small class="f-s-12 text-danger">{{ error }}</small>
                    {% endfor %}
                  </div>
                </div>
		            <input type="submit" value="Guardar" class="btn btn-primary">
                <a href="{% url 'qa-monitoring-list' %}" class="btn btn-default">Cancelar</a>
              </form>
          

        </div>
        <!-- end panel-body -->
      </div>
        <!-- end panel -->
      </div>
    <!-- end col-6 -->
    {% endif %}
  </div>
  <!-- end row -->

  <!-- begin scroll to top btn -->
  <a href="javascript:;" class="btn btn-icon btn-circle btn-success btn-scroll-to-top fade" data-click="scroll-top"><i class="fa fa-angle-up"></i></a>
  <!-- end scroll to top btn -->
{% endblock %}

{% block pageleveljs %}
<script type="text/javascript">
  //active menu
  document.getElementById("qa_menu").classList.add("active");
  //active submenu item
  document.getElementById("qamonitoring_item").classList.add("active");
</script>
<script>
  $(document).ready(function () {
    var csrftoken = $("[name=csrfmiddlewaretoken]").val();
    var phone = $("#id_phone").val();
    var email = $("#id_email").val();
    var rut = $("#id_rut").val();
    var address = $("#id_address").val();

    $.ajaxSetup({
        beforeSend: function(xhr, settings) {
          xhr.setRequestHeader("X-CSRFToken", csrftoken);
        }
    });

    function get_customer_data(data, type=''){
      var url = '{% url "data-by-phone" %}';
      var send_data = {'phone': data};
      if (type == 'rut'){
        url = '{% url "data-by-rut" %}';
        var send_data = {'rut': data};
      }else if (type == 'email'){
        url = '{% url "data-by-email" %}';
        var send_data = {'email': data};
      }
      var selected_service = {% if selected_service %}{{selected_service}}{% else %} '' {% endif %};

      $.ajax({
        type: 'POST',
        url: url,
        data: send_data
      }).done(function(data){
        if (type == ''){
          if (data['rut'] != ''){
            $('#id_rut').val(data['rut']);
          }else{
            $('#id_rut').val('');
          }
          if (data['email'] != ''){
            $('#id_email').val(data['email']);
          }else{
            $('#id_email').val(email);
          }
        }else if (type == 'email'){
          if (data['rut'] != ''){
            $('#id_rut').val(data['rut']);
          }else{
            $('#id_rut').val(rut);
          }
        }
        if (address.length > 0){
          $('#id_address').val(address);
        }else{
          if (data['address'] != ''){
            $('#id_address').val(data['address']);
          }else{
            $('#id_address').val('');
          }
        }
      
        $('#id_service').empty();
        $('#id_service').append('<option value="">-----</option>');
        $.each(data['services'], function(key, value){
          if (selected_service == value[0]){
            $('#id_service').append('<option value="'+value[0]+'" selected>'+value[1]+'</option>');
          }else{
            $('#id_service').append('<option value="'+value[0]+'">'+value[1]+'</option>');
          }
        });

        if (data['services'].length == 0){
          $('#id_service').prop('required', false);
        }else{
          $('#id_service').prop('required', true);
        }
      });
    }

    if (phone.length > 0){
      if (email.length == 0 && rut.length == 0){
        get_customer_data(phone);
      }else if (email.length > 0){
        if (rut.length == 0) {
          get_customer_data(email,'email');  
        }else{
          get_customer_data(rut,'rut');
        }
      }
    }

    $('#id_phone').blur(function(){
      $('#phone-format-error').addClass('d-none').text('');
      var valid = false;
      let phone = $(this).val();
      var regex = new RegExp("^(56)(9|2)[0-9]{8}$");
      if(!regex.test(phone)){
        var regex = new RegExp("^(9|2)[0-9]{8}$");
        if(regex.test(phone)){
          phone = '56' + phone;
          $(this).val(phone);
          valid = true;
        }
      }else{
        valid = true;
      }
      if (valid){
        get_customer_data(phone);
      }else{
        $('#id_rut').val();
        $('#id_service').empty().append('<option value="">-----</option>');
        $('#phone-format-error').removeClass('d-none').text('Error en formato');
      }
    });

    $('#id_email').blur(function(){
      $('#email-format-error').removeClass('d-none').text('');
      var valid = false;
      var email = $(this).val();
      var regex = new RegExp("^[a-zA-Z0-9._-]+@[a-zA-Z_]+?\.[a-zA-Z]{2,3}(\.[a-zA-Z]{2,10})?(\.[a-zA-Z]{2})?$");
      if(email.length == 0){
        valid = false;
      }else{
        if(!regex.test(email)){
            valid = false;
          }else{
            valid = true;
          }
      }
      
      if (valid){
        get_customer_data(email, 'email')
      }else{
        $('#id_service').empty();
        $('#id_rut').val('');
        $('#email-format-error').removeClass('d-none').text('Error en formato');
      }
    });

    $('#id_rut').blur(function(){
      $('#rut-format-error').removeClass('d-none').text('');
      var valid = false;
      var rut = $(this).val();
      var regex = new RegExp("^[0-9]{1,2}\.[0-9]{3}\.[0-9]{3}-[0-9K]{1}$");
      if(!regex.test(rut)){
        rut = rut.replace(/\./g, '').replace(/-/g, '');
        var extra = rut.substr(-1);
        if (isNaN(extra)){
          extra = extra.toUpperCase();
        }
        rut = rut.substr(0, rut.length - 1)
        rut = String(rut).replace(/(.)(?=(\d{3})+$)/g,'$1.') + '-' + extra;
        if (regex.test(rut)){
          $(this).val(rut);
          valid = true;
        }
      }else{
        valid = true;
      }
      
      if (valid){
        get_customer_data(rut, 'rut');
      }else{
        $('#id_service').empty().append('<option value="">-----</option>');
        $('#rut-format-error').removeClass('d-none').text('Error en formato');
      }
    });
    
  });
</script>
{% endblock %}
